Source10: kmodtool
%define kmodtool bash %{SOURCE10}
%{!?kversion: %define kversion 2.6.18-164.2.1.el5}

# define the kernel variants
%define upvar ""
%ifarch ppc
%define smpvar smp
%endif

%ifarch i686 x86_64 ia64
%define xenvar xen
%endif

%ifarch i686
%define PAEvar PAE
%endif

%{!?kvariants: %define kvariants %{?upvar} %{?smpvar} %{?xenvar} %{?kdumpvar} %{?PAEvar}}


%define kmod_name ocfs2
%define kverrel %(%{kmodtool} verrel %{?kversion} 2>/dev/null)

Name: ocfs2-kmod
Summary: The Oracle Cluster Filesystem 2.
Version: 1.4.4
Release: 3%{?dist}
License: GPL
Group: System Environment/Kernel
Source: ocfs2-1.4.4.tar.gz
URL: http://oss.oracle.com/projects/ocfs2/
Distribution: Oracle
Vendor: Oracle
Packager: Joel Becker <joel.becker@oracle.com>
Provides: %{name} = %{version}
#AutoReqProv: no
Requires: ocfs2-tools >= %{tools_ver}
%ifarch i386
BuildRequires: kernel-PAE-devel
%endif
BuildRequires: kernel-devel
BuildRoot: %{_tmppath}/%{name}-%{version}-root


%description
OCFS2 is the Oracle Cluster Filesystem 2.

# magic hidden here:
%{expand:%(%{kmodtool} rpmtemplate_kmp %{kmod_name} %{kverrel} %{kvariants} 2>/dev/null)}

%prep
# to understand the magic better or to debug it, uncomment this:
#{kmodtool} rpmtemplate %{kmod_name} %{kverrel} %{kvariants} 2>/dev/null
#sleep 5
%setup -q -c -T -a 0 -n ocfs2-%{version}
# individual dir for each variant
for kvariant in %{kvariants} ; do
    cp -a ocfs2-%{version} _kmod_build_${kvariant}
done


%build

for kvariant in %{kvariants}
do
	ksrc=%{_usrsrc}/kernels/%{kverrel}${kvariant:+-$kvariant}-%{_target_cpu}
	pushd _kmod_build_$kvariant
	%configure --with-vendor=rhel5 --with-vendorkernel="%{kversion}$kvariant"
	make KSRC="${ksrc}" %{?_smp_mflags}
	popd
done

%install
rm -rf $RPM_BUILD_ROOT
for kvariant in %{kvariants}
do
	ksrc=%{_usrsrc}/kernels/%{kverrel}${kvariant:+-$kvariant}-%{_target_cpu}
	pushd _kmod_build_$kvariant
	# their own rpm does something like this, don't blame me
	MOD_DIR=$RPM_BUILD_ROOT/lib/modules/%{kverrel}${kvariant}/extra/%{kmod_name}
	mkdir -p $MOD_DIR
	mkdir -p $MOD_DIR/cluster
	mkdir -p $MOD_DIR/dlm
	install fs/%{kmod_name}/cluster/ocfs2_nodemanager.ko $MOD_DIR/cluster
	install fs/%{kmod_name}/ocfs2.ko $MOD_DIR
	install fs/%{kmod_name}/dlm/ocfs2_dlm.ko $MOD_DIR/dlm
	install fs/%{kmod_name}/dlm/ocfs2_dlmfs.ko $MOD_DIR/dlm
	popd
done

%clean
rm -rf "$RPM_BUILD_ROOT"

%changelog
* Tue Oct 13 2009 Josko Plazonic <plazonic@math.princeton.edu>
- convert to weak modules

* Fri Oct 9 2009 Thomas Uphill <uphill@ias.edu> - 1.4.4
- convert to kmodtool

* Mon Nov 12 2007 Sunil Mushran <sunil.mushran@oracle.com>
- Add support to build modules for kernel-debug for RHEL5

* Thu Apr 12 2007 Sunil Mushran <sunil.mushran@oracle.com>
- Add PAE and xen for RHEL5

* Wed Feb 21 2007 Joel Becker <joel.becker@oracle.com>
- Modify for rhel5

* Thu Jun 22 2006 Sunil Mushran <sunil.mushran@oracle.com>
- Add largesmp

* Mon Jan 24 2004 Manish Singh <manish.singh@oracle.com>
- Initial rpm spec file
